Index: trunk/LMDZ.TITAN/libf/muphytitan/datasets.F90
===================================================================
--- trunk/LMDZ.TITAN/libf/muphytitan/datasets.F90	(revision 1896)
+++ trunk/LMDZ.TITAN/libf/muphytitan/datasets.F90	(revision 1897)
@@ -743,4 +799,5 @@
     ENDIF
     nd = NF90_CLOSE(fi)
+    set%dname = variable
     ret = .true.
     RETURN
@@ -757,5 +814,5 @@
     TYPE(DSET1D), INTENT(out)    :: set      !! Output dataset
     LOGICAL :: ret                           !! .true. if no errors occured, .false. otherwise
-    INTEGER                            :: fi,vi,nd
+    INTEGER                            :: fi,vi,nd,iret
     INTEGER, DIMENSION(:), ALLOCATABLE :: di,ds
     CHARACTER(len=NF90_MAX_NAME)       :: dn
@@ -766,4 +823,5 @@
     ! --- Check NetCDF file info
     IF (.NOT.get_nc_info(path,group,variable,fi,vi,di)) RETURN 
+    iret = NF90_OPEN(path,NF90_NOWRITE,fi)
     ! --- Check dimension size
     nd = SIZE(di)
@@ -778,6 +836,6 @@
     ALLOCATE(ds(nd))
     ! ------ X coordinate
-    IF (.NOT.nc_get_dim(fi,di(1),variable,set%x,ds(1))) THEN
-      CALL clear_dset(set) ; RETURN
+    IF (.NOT.nc_get_dim_by_id(fi,di(1),set%x,ds(1),set%xname)) THEN
+      nd = NF90_CLOSE(fi) ; CALL clear_dset(set) ; RETURN
     ENDIF
     ! --- Read data
@@ -788,4 +846,5 @@
     ENDIF
     nd = NF90_CLOSE(fi)
+    set%dname = variable
     ret = .true.
     RETURN
@@ -799,5 +858,5 @@
     TYPE(DSET2D), INTENT(out)    :: set      !! Output dataset
     LOGICAL :: ret                           !! .true. if no errors occured, .false. otherwise
-    INTEGER                            :: fi,vi,nd
+    INTEGER                            :: fi,vi,nd,iret
     INTEGER, DIMENSION(:), ALLOCATABLE :: di,ds
     CHARACTER(len=15)                  :: i2s
@@ -807,4 +866,5 @@
     ! --- Check NetCDF file info
     IF (.NOT.get_nc_info(path,group,variable,fi,vi,di)) rETURN
+    iret = NF90_OPEN(path,NF90_NOWRITE,fi)
     ! --- Check dimension size
     nd = SIZE(di)
@@ -819,10 +879,10 @@
     ALLOCATE(ds(nd))
     ! ------ X coordinate
-    IF (.NOT.nc_get_dim(fi,di(1),variable,set%x,ds(1))) THEN
-      CALL clear_dset(set) ; RETURN
+    IF (.NOT.nc_get_dim_by_id(fi,di(1),set%x,ds(1),set%xname)) THEN
+      nd = NF90_CLOSE(fi) ; CALL clear_dset(set) ; RETURN
     ENDIF
     ! ------ Y coordinate
-    IF (.NOT.nc_get_dim(fi,di(2),variable,set%y,ds(2))) THEN
-      CALL clear_dset(set) ; RETURN
+    IF (.NOT.nc_get_dim_by_id(fi,di(2),set%y,ds(2),set%yname)) THEN
+      nd = NF90_CLOSE(fi) ; CALL clear_dset(set) ; RETURN
     ENDIF
     ! --- Read data
@@ -833,4 +893,5 @@
     ENDIF
     nd = NF90_CLOSE(fi)
+    set%dname = variable
     ret = .true.
     RETURN
@@ -844,5 +905,5 @@
     TYPE(DSET3D), INTENT(out)    :: set      !! Output dataset
     LOGICAL :: ret                           !! .true. if no errors occured, .false. otherwise
-    INTEGER                            :: fi,vi,nd
+    INTEGER                            :: fi,vi,nd,iret
     INTEGER, DIMENSION(:), ALLOCATABLE :: di,ds
     CHARACTER(len=15)                  :: i2s
@@ -852,4 +913,5 @@
     ! --- Check NetCDF file info
     IF (.NOT.get_nc_info(path,group,variable,fi,vi,di)) RETURN 
+    iret = NF90_OPEN(path,NF90_NOWRITE,fi)
     ! --- Check dimension size
     nd = SIZE(di)
@@ -864,14 +926,14 @@
     ALLOCATE(ds(nd))
     ! ------ X coordinate
-    IF (.NOT.nc_get_dim(fi,di(1),variable,set%x,ds(1))) THEN
-      CALL clear_dset(set) ; RETURN
+    IF (.NOT.nc_get_dim_by_id(fi,di(1),set%x,ds(1),set%xname)) THEN
+      nd = NF90_CLOSE(fi) ; CALL clear_dset(set) ; RETURN
     ENDIF
     ! ------ Y coordinate
-    IF (.NOT.nc_get_dim(fi,di(2),variable,set%y,ds(2))) THEN
-      CALL clear_dset(set) ; RETURN
+    IF (.NOT.nc_get_dim_by_id(fi,di(2),set%y,ds(2),set%yname)) THEN
+      nd = NF90_CLOSE(fi) ; CALL clear_dset(set) ; RETURN
     ENDIF
     ! ------ Z coordinate
-    IF (.NOT.nc_get_dim(fi,di(3),variable,set%z,ds(3))) THEN
-      CALL clear_dset(set) ; RETURN
+    IF (.NOT.nc_get_dim_by_id(fi,di(3),set%z,ds(3),set%zname)) THEN
+      nd = NF90_CLOSE(fi) ; CALL clear_dset(set) ; RETURN
     ENDIF
     ! --- Read data
@@ -882,4 +944,5 @@
     ENDIF
     nd = NF90_CLOSE(fi)
+    set%dname = variable
     ret = .true.
     RETURN
@@ -893,5 +956,5 @@
     TYPE(DSET4D), INTENT(out)    :: set      !! Output dataset
     LOGICAL :: ret                           !! .true. if no errors occured, .false. otherwise
-    INTEGER                            :: fi,vi,nd
+    INTEGER                            :: fi,vi,nd,iret
     INTEGER, DIMENSION(:), ALLOCATABLE :: di,ds
     CHARACTER(len=15)                  :: i2s
@@ -901,4 +964,5 @@
     ! --- Check NetCDF file info
     IF (.NOT.get_nc_info(path,group,variable,fi,vi,di)) RETURN 
+    iret = NF90_OPEN(path,NF90_NOWRITE,fi)
     ! --- Check dimension size
     nd = SIZE(di)
@@ -913,18 +977,18 @@
     ALLOCATE(ds(nd))
     ! ------ X coordinate
-    IF (.NOT.nc_get_dim(fi,di(1),variable,set%x,ds(1))) THEN
-      CALL clear_dset(set) ; RETURN
+    IF (.NOT.nc_get_dim_by_id(fi,di(1),set%x,ds(1),set%xname)) THEN
+      nd = NF90_CLOSE(fi) ; CALL clear_dset(set) ; RETURN
     ENDIF
     ! ------ Y coordinate
-    IF (.NOT.nc_get_dim(fi,di(2),variable,set%y,ds(2))) THEN
-      CALL clear_dset(set) ; RETURN
+    IF (.NOT.nc_get_dim_by_id(fi,di(2),set%y,ds(2),set%yname)) THEN
+      nd = NF90_CLOSE(fi) ; CALL clear_dset(set) ; RETURN
     ENDIF
     ! ------ Z coordinate
-    IF (.NOT.nc_get_dim(fi,di(3),variable,set%z,ds(3))) THEN
-      CALL clear_dset(set) ; RETURN
+    IF (.NOT.nc_get_dim_by_id(fi,di(3),set%z,ds(3),set%zname)) THEN
+      nd = NF90_CLOSE(fi) ; CALL clear_dset(set) ; RETURN
     ENDIF
     ! ------ T coordinate
-    IF (.NOT.nc_get_dim(fi,di(4),variable,set%t,ds(4))) THEN
-      CALL clear_dset(set) ; RETURN
+    IF (.NOT.nc_get_dim_by_id(fi,di(4),set%t,ds(4),set%tname)) THEN
+      nd = NF90_CLOSE(fi) ; CALL clear_dset(set) ; RETURN
     ENDIF
     ! --- Read data
@@ -935,4 +999,5 @@
     ENDIF
     nd = NF90_CLOSE(fi)
+    set%dname = variable
     ret = .true.
     RETURN
@@ -946,5 +1011,5 @@
     TYPE(DSET5D), INTENT(out)    :: set      !! Output dataset
     LOGICAL :: ret                           !! .true. if no errors occured, .false. otherwise
-    INTEGER                            :: fi,vi,nd
+    INTEGER                            :: fi,vi,nd,iret
     INTEGER, DIMENSION(:), ALLOCATABLE :: di,ds
     CHARACTER(len=15)                  :: i2s
@@ -954,4 +1019,5 @@
     ! --- Check NetCDF file info
     IF (.NOT.get_nc_info(path,group,variable,fi,vi,di)) RETURN
+    iret = NF90_OPEN(path,NF90_NOWRITE,fi)
     ! --- Check dimension size
     nd = SIZE(di)
@@ -966,21 +1032,22 @@
     ALLOCATE(ds(nd))
     ! ------ X coordinate
-    IF (.NOT.nc_get_dim(fi,di(1),variable,set%x,ds(1))) THEN
-      CALL clear_dset(set) ; RETURN
+    IF (.NOT.nc_get_dim_by_id(fi,di(1),set%x,ds(1),set%xname)) THEN
+      nd = NF90_CLOSE(fi) ; CALL clear_dset(set) ; RETURN
     ENDIF
     ! ------ Y coordinate
-    IF (.NOT.nc_get_dim(fi,di(2),variable,set%y,ds(2))) THEN
-      CALL clear_dset(set) ; RETURN
+    IF (.NOT.nc_get_dim_by_id(fi,di(2),set%y,ds(2),set%yname)) THEN
+      nd = NF90_CLOSE(fi) ; CALL clear_dset(set) ; RETURN
     ENDIF
     ! ------ Z coordinate
-    IF (.NOT.nc_get_dim(fi,di(3),variable,set%z,ds(3))) THEN
-      CALL clear_dset(set) ; RETURN
+    IF (.NOT.nc_get_dim_by_id(fi,di(3),set%z,ds(3),set%zname)) THEN
+      nd = NF90_CLOSE(fi) ; CALL clear_dset(set) ; RETURN
     ENDIF
     ! ------ T coordinate
-    IF (.NOT.nc_get_dim(fi,di(4),variable,set%t,ds(4))) THEN
-      CALL clear_dset(set) ; RETURN
+    IF (.NOT.nc_get_dim_by_id(fi,di(4),set%t,ds(4),set%tname)) THEN
+      nd = NF90_CLOSE(fi) ; CALL clear_dset(set) ; RETURN
     ENDIF
     ! ------ W coordinate
-    IF (.NOT.nc_get_dim(fi,di(5),variable,set%w,ds(5))) THEN
+    IF (.NOT.nc_get_dim_by_id(fi,di(5),set%w,ds(5),set%wname)) THEN
+      nd = NF90_CLOSE(fi) ; CALL clear_dset(set) ; RETURN
       CALL clear_dset(set) ; RETURN
     ENDIF
@@ -992,8 +1059,8 @@
     ENDIF
     nd = NF90_CLOSE(fi)
+    set%dname = variable
     ret = .true.
     RETURN
   END FUNCTION ncdf4_rd_5d
-#endif
 #endif
 
@@ -1007,7 +1074,7 @@
     TYPE(dset1d), INTENT(out)    :: set  !! output 1D dataset
     LOGICAL :: ret                       !! .true. if no error occured, .false. otherwise
-    INTEGER                     :: i,e
-    REAL(kind=wp), DIMENSION(2) :: vl
-    INTEGER, DIMENSION(1)       :: cc,ds,dp
+    INTEGER                    :: i,e
+    REAL(kind=8), DIMENSION(2) :: vl
+    INTEGER, DIMENSION(1)      :: cc,ds,dp
     ret = .false.
     CALL clear_dset(set)
@@ -1037,7 +1104,7 @@
     TYPE(dset2d), INTENT(out)    :: set  !! output 2D dataset
     LOGICAL :: ret                       !! .true. if no error occured, .false. otherwise
-    INTEGER                     :: i,e
-    REAL(kind=wp), DIMENSION(3) :: vl 
-    INTEGER, DIMENSION(2)       :: cc,ds,dp
+    INTEGER                    :: i,e
+    REAL(kind=8), DIMENSION(3) :: vl 
+    INTEGER, DIMENSION(2)      :: cc,ds,dp
     ret = .false.
     CALL clear_dset(set)
@@ -1077,7 +1144,7 @@
     TYPE(dset3d), INTENT(out)    :: set  !! output 3D dataset
     LOGICAL :: ret                       !! .true. if no error occured, .false. otherwise
-    INTEGER                     :: i,e
-    REAL(kind=wp), DIMENSION(4) :: vl 
-    INTEGER, DIMENSION(3)       :: cc,ds,dp
+    INTEGER                    :: i,e
+    REAL(kind=8), DIMENSION(4) :: vl 
+    INTEGER, DIMENSION(3)      :: cc,ds,dp
     ret = .false.
     CALL clear_dset(set)
@@ -1120,7 +1187,7 @@
     TYPE(dset4d), INTENT(out)    :: set  !! output 4D dataset
     LOGICAL :: ret                       !! .true. if no error occured, .false. otherwise
-    INTEGER                     :: i,e
-    REAL(kind=wp), DIMENSION(5) :: vl 
-    INTEGER, DIMENSION(4)       :: cc,ds,dp
+    INTEGER                    :: i,e
+    REAL(kind=8), DIMENSION(5) :: vl 
+    INTEGER, DIMENSION(4)      :: cc,ds,dp
     ret = .false.
     CALL clear_dset(set)
@@ -1166,7 +1233,7 @@
     TYPE(dset5d), INTENT(out)    :: set  !! output 5D dataset
     LOGICAL :: ret                       !! .true. if no error occured, .false. otherwise
-    INTEGER                     :: i,e
-    REAL(kind=wp), DIMENSION(6) :: vl 
-    INTEGER, DIMENSION(5)       :: cc,ds,dp
+    INTEGER                    :: i,e
+    REAL(kind=8), DIMENSION(6) :: vl 
+    INTEGER, DIMENSION(5)      :: cc,ds,dp
     ret = .false.
     CALL clear_dset(set)
@@ -1260,3 +1327,408 @@
   END SUBROUTINE clr_5d_set
 
+  FUNCTION has_d_1d(dset) RESULT(yes)
+    !! Check whether or not the dataset has data.
+    TYPE(DSET1D), INTENT(in)     :: dset !! Dataset to check
+    LOGICAL                      :: yes  !! return status
+    yes =  (ALLOCATED(dset%data).AND. &
+            ALLOCATED(dset%x))
+  END FUNCTION has_d_1d
+
+  FUNCTION has_d_2d(dset) RESULT(yes)
+    !! Check whether or not the dataset has data.
+    TYPE(DSET2D), INTENT(in)     :: dset !! Dataset to check
+    LOGICAL                      :: yes  !! return status
+    yes =  (ALLOCATED(dset%data).AND. &
+            ALLOCATED(dset%x)   .AND. &   
+            ALLOCATED(dset%y))
+  END FUNCTION has_d_2d
+
+  FUNCTION has_d_3d(dset) RESULT(yes)
+    !! Check whether or not the dataset has data.
+    TYPE(DSET3D), INTENT(in)     :: dset !! Dataset to check
+    LOGICAL                      :: yes  !! return status
+    yes =  (ALLOCATED(dset%data).AND. &
+            ALLOCATED(dset%x)   .AND. &   
+            ALLOCATED(dset%y)   .AND. &
+            ALLOCATED(dset%z))
+  END FUNCTION has_d_3d
+
+  FUNCTION has_d_4d(dset) RESULT(yes)
+    !! Check whether or not the dataset has data.
+    TYPE(DSET4D), INTENT(in)     :: dset !! Dataset to check
+    LOGICAL                      :: yes  !! return status
+    yes =  (ALLOCATED(dset%data).AND. &
+            ALLOCATED(dset%x)   .AND. &   
+            ALLOCATED(dset%y)   .AND. &
+            ALLOCATED(dset%z)   .AND. &
+            ALLOCATED(dset%t))
+  END FUNCTION has_d_4d
+
+  FUNCTION has_d_5d(dset) RESULt(yes)
+    !! Check whether or not the dataset has data.
+    TYPE(DSET5D), INTENT(in)     :: dset !! Dataset to check
+    LOGICAL                      :: yes  !! return status
+    yes =  (ALLOCATED(dset%data).AND. &
+            ALLOCATED(dset%x)   .AND. &   
+            ALLOCATED(dset%y)   .AND. &
+            ALLOCATED(dset%z)   .AND. &
+            ALLOCATED(dset%t)   .AND. &
+            ALLOCATED(dset%w)) 
+  END FUNCTION has_d_5d
+
+  FUNCTION nc_wr_1d(path,dset) RESULT(ret)
+    CHARACTER(len=*), INTENT(in) :: path !! Path of the netcdf file.
+    TYPE(DSET1D), INTENT(in)     :: dset !! Dataset to write
+    LOGICAL                      :: ret  !! Return status
+    INTEGER                                 :: fi,vi,nd,ds,iret
+    INTEGER, DIMENSION(:), ALLOCATABLE      :: di
+    REAL(kind=8), DIMENSION(:), ALLOCATABLE :: tv
+    CHARACTER(len=15)                       :: i2s
+    LOGICAL                                 :: hxd,ok
+    INTEGER                                 :: xid,vid 
+    ret = has_data(dset)
+    IF (.NOT.ret) RETURN
+    ret = .false.
+    INQUIRE(FILE=TRIM(path),EXIST=ok)
+    IF (ok) THEN
+      IF (NF90_OPEN(TRIM(path), NF90_WRITE, fi) /= NF90_NOERR) RETURN
+    ELSE
+      IF (NF90_CREATE(TRIM(path), NF90_NOCLOBBER, fi) /= NF90_NOERR) RETURN
+    ENDIF
+    iret = NF90_CLOSE(fi)
+    ! if variable already exist: get out of here !
+    IF (get_nc_info(path,dset%dname,fi,vi,di)) RETURN
+
+    iret = NF90_OPEN(path,NF90_WRITE,fi) 
+
+    hxd = nc_get_dim_by_name(fi,dset%xname,tv,ds,xid) 
+    IF (hxd) THEN
+      IF(.NOT.compare(dset%x,tv)) THEN ; ret = .false. ; RETURN ; ENDIF
+    ENDIF
+
+    IF (.NOT.hxd) THEN
+      ret = nc_set_dim(fi,dset%xname,dset%x,xid)
+      IF (.NOT.ret) THEN ; iret= NF90_CLOSE(fi) ; RETURN ; ENDIF
+    ENDIF
+    ret = .false.
+    iret = nf90_redef(fi)
+    iret = nf90_def_var(fi, TRIM(dset%dname), nf90_double,(/xid/),vid) 
+    IF (iret /= 0) THEN ; iret = NF90_CLOSE(fi) ; RETURN ; ENDIF
+    iret = nf90_enddef(fi)
+    iret = nf90_put_var(fi,vid,dset%data)
+    ret = (iret == 0)
+    iret=NF90_CLOSE(fi)
+    ret = .true.
+    RETURN
+  END FUNCTION nc_wr_1d
+
+  FUNCTION nc_wr_2d(path,dset) RESULT(ret)
+    CHARACTER(len=*), INTENT(in) :: path !! Path of the netcdf file.
+    TYPE(DSET2D), INTENT(in)     :: dset !! Dataset to write
+    LOGICAL                      :: ret  !! Return status
+    INTEGER                                 :: fi,vi,nd,ds,iret,nferr
+    INTEGER, DIMENSION(:), ALLOCATABLE      :: di
+    REAL(kind=8), DIMENSION(:), ALLOCATABLE :: tv
+    CHARACTER(len=15)                       :: i2s
+    LOGICAL                                 :: hxd,hyd,ok
+    INTEGER                                 :: xid,yid,vid 
+    ret = has_data(dset)
+    IF (.NOT.ret) RETURN
+    ret = .false.
+    INQUIRE(FILE=TRIM(path),EXIST=ok)
+    IF (ok) THEN
+      IF (NF90_OPEN(TRIM(path), NF90_WRITE, fi) /= NF90_NOERR) RETURN
+    ELSE
+      IF (NF90_CREATE(TRIM(path), NF90_NOCLOBBER, fi) /= NF90_NOERR) RETURN
+    ENDIF
+    iret = NF90_CLOSE(fi)
+
+    ! if variable already exist: get out of here !
+    IF (get_nc_info(path,dset%dname,fi,vi,di)) RETURN
+
+    iret = NF90_OPEN(path,NF90_WRITE,fi) 
+
+    hxd = nc_get_dim_by_name(fi,dset%xname,tv,ds,xid) 
+    IF (hxd) THEN
+      IF(.NOT.compare(dset%x,tv)) THEN ; ret = .false. ; RETURN ; ENDIF
+    ENDIF
+    hyd = nc_get_dim_by_name(fi,dset%yname,tv,ds,yid) 
+    IF (hyd) THEN
+      IF(.NOT.compare(dset%y,tv)) THEN ; ret = .false. ; RETURN ; ENDIF
+    ENDIF
+
+    IF (.NOT.hxd) THEN
+      ret = nc_set_dim(fi,dset%xname,dset%x,xid)
+      IF (.NOT.ret) THEN ; iret= NF90_CLOSE(fi) ; RETURN ; ENDIF
+    ENDIF
+    IF (.NOT.hyd) THEN
+      ret = nc_set_dim(fi,dset%yname,dset%y,yid)
+      IF (.NOT.ret) THEN ; iret = NF90_CLOSE(fi) ; RETURN ; ENDIF
+    ENDIF
+    ret = .false.
+    iret = nf90_redef(fi)
+    iret = nf90_def_var(fi, TRIM(dset%dname), nf90_double,(/xid,yid/),vid) 
+    IF (iret /= 0) THEN ; iret = NF90_CLOSE(fi) ; RETURN ; ENDIF
+    iret = nf90_enddef(fi)
+    iret = nf90_put_var(fi,vid,dset%data)
+    ret = (iret == 0)
+    iret=NF90_CLOSE(fi)
+    ret = .true.
+    RETURN
+  END FUNCTION nc_wr_2d
+
+  FUNCTION nc_wr_3d(path,dset) RESULT(ret)
+    CHARACTER(len=*), INTENT(in) :: path !! Path of the netcdf file.
+    TYPE(DSET3D), INTENT(in)     :: dset !! Dataset to write
+    LOGICAL                      :: ret  !! Return status
+    INTEGER                                 :: fi,vi,nd,ds,iret
+    INTEGER, DIMENSION(:), ALLOCATABLE      :: di
+    REAL(kind=8), DIMENSION(:), ALLOCATABLE :: tv
+    CHARACTER(len=15)                       :: i2s
+    LOGICAL                                 :: hxd,hyd,hzd,ok
+    INTEGER                                 :: xid,yid,zid,vid 
+    ret = has_data(dset)
+    IF (.NOT.ret) RETURN
+    ret = .false.
+    INQUIRE(FILE=TRIM(path),EXIST=ok)
+    IF (ok) THEN
+      IF (NF90_OPEN(TRIM(path), NF90_WRITE, fi) /= NF90_NOERR) RETURN
+    ELSE
+      IF (NF90_CREATE(TRIM(path), NF90_NOCLOBBER, fi) /= NF90_NOERR) RETURN
+    ENDIF
+    iret = NF90_CLOSE(fi)
+
+    ! if variable already exist: get out of here !
+    IF (get_nc_info(path,dset%dname,fi,vi,di)) RETURN
+
+    iret = NF90_OPEN(path,NF90_WRITE,fi) 
+
+    hxd = nc_get_dim_by_name(fi,dset%xname,tv,ds,xid) 
+    IF (hxd) THEN
+      IF(.NOT.compare(dset%x,tv)) THEN ; ret = .false. ; RETURN ; ENDIF
+    ENDIF
+    hyd = nc_get_dim_by_name(fi,dset%yname,tv,ds,yid) 
+    IF (hyd) THEN
+      IF(.NOT.compare(dset%y,tv)) THEN ; ret = .false. ; RETURN ; ENDIF
+    ENDIF
+    hzd = nc_get_dim_by_name(fi,dset%zname,tv,ds,zid) 
+    IF (hzd) THEN 
+      IF(.NOT.compare(dset%z,tv)) THEN ; ret = .false. ; RETURN ; ENDIF
+    ENDIF
+
+    IF (.NOT.hxd) THEN
+      ret = nc_set_dim(fi,dset%xname,dset%x,xid)
+      IF (.NOT.ret) THEN ; iret= NF90_CLOSE(fi) ; RETURN ; ENDIF
+    ENDIF
+    IF (.NOT.hyd) THEN
+      ret = nc_set_dim(fi,dset%yname,dset%y,yid)
+      IF (.NOT.ret) THEN ; iret = NF90_CLOSE(fi) ; RETURN ; ENDIF
+    ENDIF
+    IF (.NOT.hzd) THEN
+      ret = nc_set_dim(fi,dset%zname,dset%z,zid)
+      IF (.NOT.ret) THEN ; iret = NF90_CLOSE(fi) ; RETURN ; ENDIF
+    ENDIF
+    ret = .false.
+    iret = nf90_redef(fi)
+    iret = nf90_def_var(fi, TRIM(dset%dname), nf90_double,(/xid,yid,zid/),vid) 
+    IF (iret /= 0) THEN ; iret = NF90_CLOSE(fi) ; RETURN ; ENDIF
+    iret = nf90_enddef(fi)
+    iret = nf90_put_var(fi,vid,dset%data)
+    ret = (iret == 0)
+    iret=NF90_CLOSE(fi)
+    ret = .true.
+    RETURN
+  END FUNCTION nc_wr_3d
+
+  FUNCTION nc_wr_4d(path,dset) RESULT(ret)
+    CHARACTER(len=*), INTENT(in) :: path !! Path of the netcdf file.
+    TYPE(DSET4D), INTENT(in)     :: dset !! Dataset to write
+    LOGICAL                      :: ret  !! Return status
+    INTEGER                                 :: fi,vi,nd,ds,iret
+    INTEGER, DIMENSION(:), ALLOCATABLE      :: di
+    REAL(kind=8), DIMENSION(:), ALLOCATABLE :: tv
+    CHARACTER(len=15)                       :: i2s
+    LOGICAL                                 :: hxd,hyd,hzd,htd,ok
+    INTEGER                                 :: xid,yid,zid,tid,vid 
+    ret = has_data(dset)
+    IF (.NOT.ret) RETURN
+    ret = .false.
+    INQUIRE(FILE=TRIM(path),EXIST=ok)
+    IF (ok) THEN
+      IF (NF90_OPEN(TRIM(path), NF90_WRITE, fi) /= NF90_NOERR) RETURN
+    ELSE
+      IF (NF90_CREATE(TRIM(path), NF90_NOCLOBBER, fi) /= NF90_NOERR) RETURN
+    ENDIF
+    iret = NF90_CLOSE(fi)
+
+    ! if variable already exist: get out of here !
+    IF (get_nc_info(path,dset%dname,fi,vi,di)) RETURN
+
+    iret = NF90_OPEN(path,NF90_WRITE,fi) 
+
+    hxd = nc_get_dim_by_name(fi,dset%xname,tv,ds,xid) 
+    IF (hxd) THEN
+      IF(.NOT.compare(dset%x,tv)) THEN ; ret = .false. ; RETURN ; ENDIF
+    ENDIF
+    hyd = nc_get_dim_by_name(fi,dset%yname,tv,ds,yid) 
+    IF (hyd) THEN
+      IF(.NOT.compare(dset%y,tv)) THEN ; ret = .false. ; RETURN ; ENDIF
+    ENDIF
+    hzd = nc_get_dim_by_name(fi,dset%zname,tv,ds,zid) 
+    IF (hzd) THEN 
+      IF(.NOT.compare(dset%z,tv)) THEN ; ret = .false. ; RETURN ; ENDIF
+    ENDIF
+    htd = nc_get_dim_by_name(fi,dset%tname,tv,ds,tid) 
+    IF (htd) THEN
+      IF(.NOT.compare(dset%t,tv)) THEN ; ret = .false. ; RETURN ; ENDIF
+    ENDIF
+
+    IF (.NOT.hxd) THEN
+      ret = nc_set_dim(fi,dset%xname,dset%x,xid)
+      IF (.NOT.ret) THEN ; iret= NF90_CLOSE(fi) ; RETURN ; ENDIF
+    ENDIF
+    IF (.NOT.hyd) THEN
+      ret = nc_set_dim(fi,dset%yname,dset%y,yid)
+      IF (.NOT.ret) THEN ; iret = NF90_CLOSE(fi) ; RETURN ; ENDIF
+    ENDIF
+    IF (.NOT.hzd) THEN
+      ret = nc_set_dim(fi,dset%zname,dset%z,zid)
+      IF (.NOT.ret) THEN ; iret = NF90_CLOSE(fi) ; RETURN ; ENDIF
+    ENDIF
+    IF (.NOT.htd) THEN
+      ret = nc_set_dim(fi,dset%tname,dset%t,tid)
+      IF (.NOT.ret) THEN ; iret = NF90_CLOSE(fi) ; RETURN ; ENDIF
+    ENDIF
+    ret = .false.
+    iret = nf90_redef(fi)
+    iret = nf90_def_var(fi, TRIM(dset%dname), nf90_double,(/xid,yid,zid,tid/),vid) 
+    IF (iret /= 0) THEN ; iret = NF90_CLOSE(fi) ; RETURN ; ENDIF
+    iret = nf90_enddef(fi)
+    iret = nf90_put_var(fi,vid,dset%data)
+    ret = (iret == 0)
+    iret=NF90_CLOSE(fi)
+    ret = .true.
+    RETURN
+  END FUNCTION nc_wr_4d
+
+  FUNCTION nc_wr_5d(path,dset) RESULT(ret)
+    CHARACTER(len=*), INTENT(in) :: path !! Path of the netcdf file.
+    TYPE(DSET5D), INTENT(in)     :: dset !! Dataset to write
+    LOGICAL                      :: ret  !! Return status
+    INTEGER                                 :: fi,vi,nd,ds,iret
+    INTEGER, DIMENSION(:), ALLOCATABLE      :: di
+    REAL(kind=8), DIMENSION(:), ALLOCATABLE :: tv
+    CHARACTER(len=15)                       :: i2s
+    LOGICAL                                 :: hxd,hyd,hzd,htd,hwd,ok 
+    INTEGER                                 :: xid,yid,zid,tid,wid,vid 
+    ret = has_data(dset)
+    IF (.NOT.ret) RETURN
+    ret = .false.
+    INQUIRE(FILE=TRIM(path),EXIST=ok)
+    IF (ok) THEN
+      IF (NF90_OPEN(TRIM(path), NF90_WRITE, fi) /= NF90_NOERR) RETURN
+    ELSE
+      IF (NF90_CREATE(TRIM(path), NF90_NOCLOBBER, fi) /= NF90_NOERR) RETURN
+    ENDIF
+    iret = NF90_CLOSE(fi)
+
+    ! if variable already exist: get out of here !
+    IF (get_nc_info(path,dset%dname,fi,vi,di)) RETURN
+
+    iret = NF90_OPEN(path,NF90_WRITE,fi) 
+
+    hxd = nc_get_dim_by_name(fi,dset%xname,tv,ds,xid) 
+    IF (hxd) THEN
+      IF(.NOT.compare(dset%x,tv)) THEN ; ret = .false. ; RETURN ; ENDIF
+    ENDIF
+    hyd = nc_get_dim_by_name(fi,dset%yname,tv,ds,yid) 
+    IF (hyd) THEN
+      IF(.NOT.compare(dset%y,tv)) THEN ; ret = .false. ; RETURN ; ENDIF
+    ENDIF
+    hzd = nc_get_dim_by_name(fi,dset%zname,tv,ds,zid) 
+    IF (hzd) THEN 
+      IF(.NOT.compare(dset%z,tv)) THEN ; ret = .false. ; RETURN ; ENDIF
+    ENDIF
+    htd = nc_get_dim_by_name(fi,dset%tname,tv,ds,tid) 
+    IF (htd) THEN
+      IF(.NOT.compare(dset%t,tv)) THEN ; ret = .false. ; RETURN ; ENDIF
+    ENDIF
+    hwd = nc_get_dim_by_name(fi,dset%wname,tv,ds,wid) 
+    IF (hwd) THEN 
+      IF (.NOT.compare(dset%w,tv)) THEN ; ret = .false. ; RETURN ; ENDIF
+    ENDIF
+
+    IF (.NOT.hxd) THEN
+      ret = nc_set_dim(fi,dset%xname,dset%x,xid)
+      IF (.NOT.ret) THEN ; iret= NF90_CLOSE(fi) ; RETURN ; ENDIF
+    ENDIF
+    IF (.NOT.hyd) THEN
+      ret = nc_set_dim(fi,dset%yname,dset%y,yid)
+      IF (.NOT.ret) THEN ; iret = NF90_CLOSE(fi) ; RETURN ; ENDIF
+    ENDIF
+    IF (.NOT.hzd) THEN
+      ret = nc_set_dim(fi,dset%zname,dset%z,zid)
+      IF (.NOT.ret) THEN ; iret = NF90_CLOSE(fi) ; RETURN ; ENDIF
+    ENDIF
+    IF (.NOT.htd) THEN
+      ret = nc_set_dim(fi,dset%tname,dset%t,tid)
+      IF (.NOT.ret) THEN ; iret = NF90_CLOSE(fi) ; RETURN ; ENDIF
+    ENDIF
+    IF (.NOT.hwd) THEN
+      ret = nc_set_dim(fi,dset%wname,dset%w,wid)
+      IF (.NOT.ret) THEN ; iret = NF90_CLOSE(fi) ; RETURN ; ENDIF
+    ENDIF
+    ret = .false.
+    iret = nf90_redef(fi)
+    iret = nf90_def_var(fi, TRIM(dset%dname), nf90_double,(/xid,yid,zid,tid,wid/),vid) 
+    IF (iret /= 0) THEN ; iret = NF90_CLOSE(fi) ; RETURN ; ENDIF
+    iret = nf90_enddef(fi)
+    iret = nf90_put_var(fi,vid,dset%data)
+    ret = (iret == 0)
+    iret=NF90_CLOSE(fi)
+    ret = .true.
+    RETURN
+  END FUNCTION nc_wr_5d
+
+  FUNCTION nc_set_dim(fid,name,values,dimid) RESULT(ret)
+    !! Set a new dimension (and its associated values) in a NetCDF file.
+    INTEGER, INTENT(in)                    :: fid    !! Netcdf file id.
+    CHARACTER(len=*), INTENT(in)           :: name   !! Name of the dimension to set.
+    REAL(kind=8), DIMENSION(:), INTENT(in) :: values !! Associated values.
+    INTEGER, INTENT(out)                   :: dimid  !! Output dimension id.
+    LOGICAL                                :: ret    !! Return status
+    INTEGER :: iret,vid
+    ret = .false.
+    iret = nf90_redef(fid)
+    iret = nf90_def_dim(fid, TRIM(name), size(values), dimid)
+    WRITE(*,'(a)') "nc_set_dim: "//TRIM(name)//" --> "//TRIM(nf90_strerror(iret))
+    IF (iret /=0) RETURN
+    iret = nf90_def_var(fid, TRIM(name), nf90_double,(/dimid/),vid) 
+    IF (iret /=0) RETURN
+    iret = nf90_enddef(fid)
+    iret = nf90_put_var(fid, vid,values)
+    ret = .true.
+  END FUNCTION nc_set_dim
+
+  FUNCTION compare(vec1,vec2,tol) RESULT(ret)
+    !! Compare two vector of double.
+    !!
+    !! The test is checked against the difference (element wise) of the two vector compared to
+    !! to a given tolerance.
+    REAL(kind=8), DIMENSION(:), INTENT(in) :: vec1 !! First vector to compare
+    REAL(kind=8), DIMENSION(:), INTENT(in) :: vec2 !! Second vector to compare
+    REAL(kind=8), INTENT(in), OPTIONAL     :: tol  !! Tolerance to apply for the comparison
+    LOGICAL :: ret                                 !! .true. if both vectors are equal, .false. otherwise.
+    REAL(kind=8) :: ztol
+    INTEGER      :: i
+    ztol = 1d-10 ; IF (PRESENT(tol)) ztol = abs(tol)
+    ret = .false.
+    IF (size(vec1) /= size(vec2)) RETURN
+
+    DO i=1,size(vec1) ; IF (abs(vec1(i)-vec2(i)) > ztol) RETURN ; ENDDO
+    ret = .true.
+  END FUNCTION compare
+
+
+
 END MODULE DATASETS
Index: trunk/LMDZ.TITAN/libf/muphytitan/defined.h
===================================================================
--- trunk/LMDZ.TITAN/libf/muphytitan/defined.h	(revision 1896)
+++ trunk/LMDZ.TITAN/libf/muphytitan/defined.h	(revision 1897)
@@ -1,5 +1,5 @@
-/* Copyright Jérémie Burgalat (2010-2015)
+/* Copyright Jérémie Burgalat (2010-2015,2017)
  * 
- * burgalat.jeremie@gmail.com
+ * jeremie.burgalat@univ-reims.fr
  * 
  * This software is a computer program whose purpose is to provide configuration 
@@ -76,9 +76,9 @@
 /* Defines SSLEN if needed */
 #ifndef SSLEN
-#define SSLEN 200
+#define SSLEN 250
 #endif
 
 /* Defines SLLEN if needed */
 #ifndef SLLEN
-#define SLLEN 2000
+#define SLLEN 2500
 #endif
Index: trunk/LMDZ.TITAN/libf/muphytitan/errors.F90
===================================================================
--- trunk/LMDZ.TITAN/libf/muphytitan/errors.F90	(revision 1896)
+++ trunk/LMDZ.TITAN/libf/muphytitan/errors.F90	(revision 1897)
@@ -1,5 +1,5 @@
-! Copyright Jérémie Burgalat (2010-2015)
-! 
-! burgalat.jeremie@gmail.com
+! Copyright Jérémie Burgalat (2010-2015,2017)
+! 
+! jeremie.burgalat@univ-reims.fr
 ! 
 ! This software is a computer program whose purpose is to provide configuration 
@@ -33,7 +33,7 @@
 
 !! file: errors.F90
-!! summary: Errors handling source file
-!! author: Burgalat
-!! date: 2013-2015
+!! summary: Errors handling source file.
+!! author: J. Burgalat
+!! date: 2013-2015,2017
 
 #include "defined.h"
@@ -84,4 +84,5 @@
     CONTAINS
       PROCEDURE, PUBLIC :: to_string => error_to_string
+        !! Get a string representation of the error
 #endif
   END TYPE error
@@ -201,5 +202,5 @@
     IF (err /= 0) THEN
       WRITE(*,'(a)') error_to_string(err)
-      CALL EXIT(abs(err%id))
+      CALL EXIT(err%id)
     ENDIF
   END SUBROUTINE aborting
@@ -229,5 +230,5 @@
     !! The method raises an assertion and stops the execution if __test__ is .false.
     !! 
-    !! See [[errors(module):assert_r(subroutine)] remark.
+    !! See [[errors(module):assert_r(subroutine)]] remark.
     LOGICAL, INTENT(in)         :: test
      !! Expression to test.
@@ -242,4 +243,29 @@
   END SUBROUTINE assert_w
 
+  FUNCTION free_lun() RESULT(lu)
+    !> Get the first free logical unit
+    !!
+    !! The function loops from 7 to 9999 and returns the first free logical unit.
+    !! @note
+    !! According to Fortran standard, the maximum value for a lun is processor
+    !! dependent. I just assume that [7,9999] is a valid range and I believe that 
+    !! 9992 files to be opened is far enough for any program !
+    !! @note
+    !! If you intend to use loggers object from this library, you should keep in
+    !! mind that loggers open files with the first free logical unit. Consequently
+    !! if you need to perform I/O operations you should use this function to get a
+    !! free lun instead of just randomly set a lun ! 
+    INTEGER :: lu
+      !! First free logical unit in the range [7,9999]  or -1 if no lun is available
+    INTEGER, PARAMETER :: mxlu = 9999
+    LOGICAL :: notfree
+    lu = 6 ; notfree = .true.
+    DO WHILE(notfree.AND.lu<=mxlu)
+      lu=lu+1 ; INQUIRE(unit=lu,OPENED=notfree)
+    ENDDO
+    IF (lu >= mxlu) lu = -1
+  END FUNCTION free_lun
+
+
 
 END MODULE ERRORS
